#ifndef CYLINDERSCENE_H_INCLUDED
#define CYLINDERSCENE_H_INCLUDED

#include <vector>
#include <iostream>
#include <math.h>
#include "Vector3d.h"
#include "Scene.h"

using std::cout;
using std::endl;
using std::vector;

class CylinderScene : public Scene
{
    public:
        CylinderScene(SDL_Surface *sdlsurf);
        ~CylinderScene();

        void render();

        class Circle
        {
            public:
                Circle(int i)
                {
                    float radius;
                    for (int j = 0; j < 32; j++) {
                        if (i % 2 == 0) {
                            if (i % 4 == 0) {
                                if (j % 2 == 0)
                                    radius = 5.5;
                                else
                                    radius = 3.0;
                            } else
                                if (j % 2 == 1)
                                    radius = 5.5;
                                else
                                    radius = 3.0;
                        } else {
                            radius = 3.0;
                        }

                        radiuses[j] = radius;
                    }

                    float angle;
                    float PI = 3.141592654;

                    for (int j = 0; j < 32; j++) {
                        angle = (float)((2.0*PI)/32.0*j);

                        points[j].x = radiuses[j]*sin(angle);
                        points[j].y = (float)(29-i)-14.5; // z-values from + to -14.5
                        points[j].z = radiuses[j]*cos(angle);      
                    }
                }

                Vector3d points[32];
                float radiuses[32];
        };

    private:
        float rotation[30];
        vector<Circle*> circles;

        void updateRotations();
        void rotateCircle(Circle* circle, float rot);
};

#endif

