#include <iostream>
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
#include "Texture.h"
#include "FunkyBackground.h"

/* FunkyBackground::getFunky()-routine is from Dr.Fungi goes Africa by Fit */

using std::cout;
using std::endl;

FunkyBackground::FunkyBackground(SDL_Surface *sdlsurf)
{
    surface = sdlsurf;

    background = new Texture("data/background1.png");

    //init();

    MAX_X = 16;
    MAX_Y = 16;
    SIZE_X = 4.5f;
    SIZE_Y = -3.5f;
    DIS = 0.1f;
    TEXTUREJA = 12;
    SW = 0.1f;
    FACT = 1.0f;
}

FunkyBackground::~FunkyBackground()
{
    cout << framesDrawn << " frames draw\tAverage fps: " <<
        (float)framesDrawn/((float)getTime()/1000.0) << endl;

    delete background;
}

void FunkyBackground::render()
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    glTranslatef(0.0, 0.0,-2.5);
    getFunky((float)getTime()/1000.0, 9, 0);

    SDL_GL_SwapBuffers();
}

void FunkyBackground::init()
{
    glPushAttrib(GL_ALL_ATTRIB_BITS);

    startTime = SDL_GetTicks();
    framesDrawn = 0;

    // OpenGL stuff
    glClearColor(0.7, 0.7, 0.7, 0.0);
    glViewport(0, 0, 640, 480);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0, 640.0/480.0, 1.0, 100.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    glShadeModel(GL_SMOOTH);
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

    glEnable(GL_TEXTURE_2D);
}

void FunkyBackground::getFunky(float tim,int i,float swirl)
{
    int x,y;
    float dx,dy;

    float tid = tim*3.0f;
    float s2,c2;

    swirl *= 5.0f;

    glMatrixMode(GL_MODELVIEW);

    glPushMatrix();

    glTranslatef(-SIZE_X/2.0f,-SIZE_Y/2.0f,-1.0f);
    glDisable(GL_CULL_FACE);
    glEnable(GL_DEPTH_TEST);

    background->bind();
    glDepthMask(0);
    glColor3f(1.0f,1.0f,1.0f);
    glEnable(GL_COLOR_MATERIAL);
    glBegin(GL_QUADS);

    for(y = 0; y<MAX_Y; y++) {
        for(x = 0; x<MAX_X; x++) {
            s2 = (float)sin(x+y+swirl)*SW;
            c2 = (float)cos(x+y+swirl)*SW;
            dx = (sin(x+tid)*DIS)+(s2*swirl*DIS*10.0f);
            dy = cos(y+tid)*DIS+(c2*swirl*DIS*10.0f);
            glTexCoord2f((float)x/MAX_X    ,(float)y/MAX_Y);
            glVertex3f(x*SIZE_X/MAX_X + dx,y*SIZE_Y/MAX_Y  + dy   ,0);


            s2 = (float)sin(x+1+y+swirl)*SW;
            c2 = (float)cos(x+1+y+swirl)*SW;
            dx = sin(x+1+tid)*DIS+(s2*swirl*DIS*10.0f);
            dy = cos(y+tid)*DIS+(c2*swirl*DIS*10.0f);
            glTexCoord2f((float)(x+1)/MAX_X,(float)y/MAX_Y);
            glVertex3f((x+1)*SIZE_X/MAX_X + dx,y*SIZE_Y/MAX_Y  + dy   ,0);

            s2 = sin(x+2+y+swirl)*SW;
            c2 = cos(x+2+y+swirl)*SW;
            dx = sin(x+1+tid)*DIS+(s2*swirl*DIS*10.0f);
            dy = cos(y+1+tid)*DIS+(c2*swirl*DIS*10.0f);
            glTexCoord2f((float)(x+1)/MAX_X,(float)(y+1)/MAX_Y);
            glVertex3f((x+1)*SIZE_X/MAX_X + dx,(y+1)*SIZE_Y/MAX_Y + dy,0);

            s2 = sin(x+1+y+swirl)*SW;
            c2 = cos(x+1+y+swirl)*SW;
            dx = sin(x+tid)*DIS+(s2*swirl*DIS*10.0f);
            dy = cos(y+1+tid)*DIS+(c2*swirl*DIS*10.0f);
            glTexCoord2f((float)x/MAX_X    ,(float)(y+1)/MAX_Y);
            glVertex3f(x*SIZE_X/MAX_X + dx    ,(y+1)*SIZE_Y/MAX_Y + dy,0);
        }
    }
    glEnd();

    glDisable(GL_DEPTH_TEST);
    glDepthMask(1);

    glPopMatrix();

    glColor3f(1,1,1);
}

