#include <iostream>
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
#include "Texture.h"
#include "Greetings.h"

using std::cout;
using std::endl;

void drawCube(float size);

Greetings::Greetings(SDL_Surface *sdlsurf)
{
    surface = sdlsurf;

    greetings = new Texture("data/hils.png");

    //init();

    z = 1;
    start1 = 4;
    start2 = 1; 
    s1f = 0.01;
    s2f = -0.01;
    rot = 0.0;
}

Greetings::~Greetings()
{
    deinit();
    cout << framesDrawn << " frames draw\tAverage fps: " <<
        (float)framesDrawn/((float)getTime()/1000.0) << endl;

    delete greetings;
}

void Greetings::render()
{
    glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
    glLoadIdentity();

    int x, y;

    {
        if(start1 > 4)
        {
            start1 = 3.9;
            s1f = -0.01;
        }
        if(start1 < 0)
        {
            start1 = 0.1;
            s1f = 0.01;
        }

        start1 += s1f;

        if(start2 > 4)
        {
            start2 = 3.9;
            s2f = -0.01;
        }
        if(start2 < 0)
        {
            start2 = 0.1;
            s2f = 0.01;
        }

        start2 += s2f;
        rot += 0.1;
    }

    start1 = sinf((float)getTime()/500.0);
    start2 = sinf((float)getTime()/500.0);

    for(y = -18; y < 18; y += 5)
    {
        glLoadIdentity();

        glTranslatef(-20, y, -30);
        glRotatef(-30, 1, 1, 1);

        z = start1;

        for(x = -18; x <0;x+=4)
        {
            if(z > 4)
                z = 4;

            glTranslatef(4, 0, 0);
            glColor3f(0.0, 0.1, 0.6);
            drawCube(z);
            glColor3f(0.3, 0.0, 0.2);
            glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
            drawCube(z);
            glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
            z -= 0.5;
        }
    }


    for(y = -18; y < 18; y += 5)
    {
        glLoadIdentity();

        glTranslatef(-20, y, -90);
        glRotatef(-30, 1, 1, 1);

        z = start1;

        for(x = -18; x <-9;x+=4)
        {
            if(z > 4)
                z = 4;

            glTranslatef(4, 0, 0);
            glColor3f(0.0, 0.1, 0.6);
            drawCube(z);
            glColor3f(0.3, 0.0, 0.2);
            glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
            drawCube(z);
            glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
            z -= 0.5;
        }
    }

    for(y = -18; y < 18; y += 5)
    {
        glLoadIdentity();

        glTranslatef(-20, y, -40);
        glRotatef(-30, 1, 1, 1);

        z = start1;

        for(x = -10; x <0;x+=4)
        {
            if(z > 4)
                z = 4;

            glTranslatef(4, 0, 0);
            glColor3f(0.0, 0.1, 0.6);
            drawCube(z);
            glColor3f(0.3, 0.0, 0.2);
            glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
            drawCube(z);
            glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
            z -= 0.5;
        }
    }
    for(y = -18; y < 18; y += 5)
    {
        glLoadIdentity();

        glTranslatef(-20, y, -70);
        glRotatef(-30, 1, 1, 1);

        z = start2;

        for(x = -10; x <0;x+=4)
        {
            if(z > 4)
                z = 4;

            glTranslatef(4, 0, 0);
            glColor3f(0.0, 0.1, 0.6);
            drawCube(z);
            glColor3f(0.3, 0.0, 0.2);
            glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
            drawCube(z);
            glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
            z -= 0.5;
        }
    }

    set640x480();
    glColor3f(1.0, 1.0, 1.0);
    greetings->bind();
    if (getTime() < 1000) {
        glTranslatef(0.1, 0.0, 0.0);
    }
    else if (getTime() < 2000) {
        glTranslatef(0.4, 0.0, 0.0);
        glRotatef(5.0, 0.0, 0.0, 1.0);
    }
    else if (getTime() < 3000) {
        glTranslatef(0.2, 0.0, 0.0);
        glRotatef(5.0, 0.0, 0.0, 1.0);
    }
    else if (getTime() < 4000) {
        glTranslatef(0.2, 0.1, 0.0);
        glRotatef(-3.0, 0.0, 0.0, 1.0);
    }
    else if (getTime() < 5000) {
        glTranslatef(0.0, 0.1, 0.0);
        glRotatef(-3.1, 0.0, 0.0, 1.0);
    }
    else if (getTime() < 6000) {
        glTranslatef(0.2, 0.2, 0.0);
        glRotatef( 3.0, 0.0, 0.0, 1.0);
    }
    else if (getTime() < 7000) {
        glTranslatef(0.1,-0.1, 0.0);
        glRotatef(0.0, 0.0, 0.0, 1.0);
    }
    else if (getTime() < 8000) {
        glTranslatef(0.4, 0.1, 0.0);
        glRotatef(-2.3, 0.0, 0.0, 1.0);
    }
    else if (getTime() < 9000) {
        glTranslatef(-0.1, 0.1, 0.0);
        glRotatef(8.0, 0.0, 0.0, 1.0);
    }
    glBegin(GL_QUADS);
    {
        glTexCoord2i(0, 0); glVertex2i(383, 495);
        glTexCoord2i(1, 0); glVertex2i(639, 495);
        glTexCoord2i(1, 1); glVertex2i(639, -16);
        glTexCoord2i(0, 1); glVertex2i(383, -16);
    }
    glEnd();
    glBindTexture(GL_TEXTURE_2D, GL_NONE);
    unsetOrtho();

    // FIXME
    // fade in
    if (getTime() < 1000) {
        setOrtho();
        glDisable(GL_DEPTH_TEST);
        glDisable(GL_TEXTURE_2D);
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
        glColor4f(0.0, 0.0, 0.0, 1.0-(float)getTime()/1000.0);
        glBegin(GL_QUADS);
        {
            glVertex2i(-1,-1);
            glVertex2i( 1,-1);
            glVertex2i( 1, 1);
            glVertex2i(-1, 1);
        }
        glEnd();
        glEnable(GL_DEPTH_TEST);
        glEnable(GL_TEXTURE_2D);
        unsetOrtho();
    }

    // FIXME
    // fade out
    if (getTime() > 9000) {
        setOrtho();
        glDisable(GL_DEPTH_TEST);
        glDisable(GL_TEXTURE_2D);
        glColor4f(0.0, 0.0, 0.0, (float)(getTime()-9000)/1000.0);
        glBegin(GL_QUADS);
        {
            glVertex2i(-1,-1);
            glVertex2i( 1,-1);
            glVertex2i( 1, 1);
            glVertex2i(-1, 1);
        }
        glEnd();
        glEnable(GL_DEPTH_TEST);
        glEnable(GL_TEXTURE_2D);
        unsetOrtho();
    }

    // FIXME
    // fade out
    if (getTime() > 9000) {
        setOrtho();
        glDisable(GL_DEPTH_TEST);
        glColor4f(0.0, 0.0, 0.0, ((float)(getTime()-9000))/1000.0);
        glBegin(GL_QUADS);
        {
            glVertex2i(-1,-1);
            glVertex2i( 1,-1);
            glVertex2i( 1, 1);
            glVertex2i(-1, 1);
        }
        glEnd();
        glEnable(GL_DEPTH_TEST);
        unsetOrtho();
    }

    // FIXME
    // fade in
    if (getTime() < 1000) {
        setOrtho();
        glDisable(GL_DEPTH_TEST);
        glColor4f(0.0, 0.0, 0.0, 1.0-(float)getTime()/1000.0);
        glBegin(GL_QUADS);
        {
            glVertex2i(-1,-1);
            glVertex2i( 1,-1);
            glVertex2i( 1, 1);
            glVertex2i(-1, 1);
        }
        glEnd();
        glEnable(GL_DEPTH_TEST);
        unsetOrtho();
    }

    SDL_GL_SwapBuffers();
}

void Greetings::init()
{
    glPushAttrib(GL_ALL_ATTRIB_BITS);

    startTime = SDL_GetTicks();
    framesDrawn = 0;

    // OpenGL stuff
//    glMatrixMode(GL_PROJECTION);
//    gluPerspective(45, 1.33, 1, 100);
    glMatrixMode(GL_MODELVIEW);
    glClearColor(0.6, 0.2, 0.3, 0.0);
    glEnable(GL_DEPTH_TEST);
    glLineWidth(5);
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
}

void Greetings::drawCube(float size)
{
    float d = size/2.0;

    glBegin(GL_QUADS);
    {
        // front
        glVertex3f(-d,-d, d);
        glVertex3f( d,-d, d);
        glVertex3f( d, d, d);
        glVertex3f(-d, d, d);
        // back
        glVertex3f(-d,-d,-d);
        glVertex3f( d,-d,-d);
        glVertex3f( d, d,-d);
        glVertex3f(-d, d,-d);
        // top
        glVertex3f(-d, d, d);
        glVertex3f( d, d, d);
        glVertex3f( d, d,-d);
        glVertex3f(-d, d,-d);
        // bottom
        glVertex3f(-d,-d, d);
        glVertex3f( d,-d, d);
        glVertex3f( d,-d,-d);
        glVertex3f(-d,-d,-d);
        // left
        glVertex3f(-d,-d,-d);
        glVertex3f(-d,-d, d);
        glVertex3f(-d, d, d);
        glVertex3f(-d, d,-d);
        // right
        glVertex3f( d,-d,-d);
        glVertex3f( d,-d, d);
        glVertex3f( d, d, d);
        glVertex3f( d, d,-d);
    }
    glEnd();
}
