#ifndef HEIGHTFIELD_H_INCLUDED
#define HEIGHTFIELD_H_INCLUDED

#include <math.h>
#include "Vector3d.h"
#include "Scene.h"
#include "Texture.h"

class Heightfield : public Scene
{
    public:
        Heightfield(SDL_Surface *sdlsurf);
        ~Heightfield();

        void render();
        void init();

    private:
        float map[5000];
        int mc;
        int mcounter;
        float rot;
        float ticks;

        void rendermap(int start, int stopp, int px, int pz, int zmin,
                int zmax, int xmin, int xmax);

        float noise(float x, float y);
        void genmap();

        Texture* dude;
        Texture* ting;
        Texture* smegma;
        Texture* wemade;

        // cel-stuff
        bool outlineSmooth;
        float outlineColor[3];
        float outlineWidth;
        Vector3d lightAngle;
        float shaderData[32][3]; // Storate For The 96 Shader Values 
        GLuint shaderTexture[1]; // Storage For One Texture

        void renderCelPr0n();

        unsigned int bump;
};

#endif

