#include <iostream>
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
#include "LoaderBar.h"

using std::cout;
using std::endl;

LoaderBar::LoaderBar(SDL_Surface *sdlsurf)
{
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    surface = sdlsurf;

    init();
}

LoaderBar::~LoaderBar()
{
}

void LoaderBar::render()
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    SDL_GL_SwapBuffers();
}

void LoaderBar::render(int percent)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    setOrtho();
    glColor3f(1.0, 1.0, 1.0);
    // frame
    glBegin(GL_LINE_LOOP);
    {
        glVertex2f(-0.8,-0.1);
        glVertex2f( 0.8,-0.1);
        glVertex2f( 0.8, 0.1);
        glVertex2f(-0.8, 0.1);
    }
    glEnd();

    // bar
    glBegin(GL_QUADS);
    {
        glVertex2f(-0.792,-0.09);
        glVertex2f( .01584*percent-0.792,-0.09);
        glVertex2f( .01584*percent-0.792, 0.09);
        glVertex2f(-0.792, 0.09);
    }
    glEnd();
    unsetOrtho();

    SDL_GL_SwapBuffers();
}

void LoaderBar::init()
{
    startTime = getTime();
    framesDrawn = 0;

    // OpenGL stuff
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glViewport(0, 0, 640, 480);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0, 640.0/480.0, 1.0, 100.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}


