#ifndef METABALLS_H_INCLUDED
#define METABALLS_H_INCLUDED

#include <math.h>
#include "Vector3d.h"
#include "Scene.h"
#include "Vector3d.h"
#include "PNGImage.h"
#include "Texture.h"

class Metaballs : public Scene
{
    public:
        Metaballs(SDL_Surface *sdlsurf);
        ~Metaballs();

        void render();
        void init();


        // klasse for  holde en ball :)
        class metaball
        {
            public:
                double radius;
                double threshold;
                double kraft;
                Vector3d pos;
        };

        class sfelt
        {
            public:
                Vector3d pos;
                Vector3d normal;
                double kraft;
                int inni;
        };

        // teh whole shiznit.
        class metaballer
        {
            public:
                int nballer; // heheh... baller
                Vector3d d;
                double radius;
                double threshold; // threshold = minimumsverdi for at et punkt er i surfacen.
                metaball baller[12];
                sfelt skalarfelt[40 * 40 * 40];
                int nvertexer;
                double mesh[10000];
                int gridx, gridy, gridz;
                int wxstart, wxslutt, wystart, wyslutt, wzstart, wzslutt;
        };

    private:
        Texture* ting;
        PNGImage* pngTexture;

        metaballer baller;
        GLuint texid;

        float rot;
        int t;

        // strrelsen p verden.
        int WORLDX;
        int WORLDY;
        int WORLDZ;

        // definisjoner for om en vertex er innenfor/utenfor surfacen.
        int INNENFOR;
        int UTENFOR;

        /* initialiser en ball. */
        void initmetaball(double radius, double threshold, double kraft,
                float x, float y, float z, metaball* ball);

        void regnfelt(metaballer *baller);

        void printmetaballinfo(metaball *ball, int i);

        void printmetaballsinfo(metaballer *baller);

        void printskalarfeltinfo(metaballer *baller);

        /* initialiser metaballer. */
        void initmetaballs(int n, double radius, int gridx, int gridy, int gridz, 
                int wxstart, int wxslutt, int wystart, int wyslutt,
                int wzstart, int wzslutt, metaballer *baller);

        /* kraft i et punkt. */
        void kraft(int index);

        void tegngrid();

        void lagkube(int kindex[8], int index);

        /* finn ut hvor vi skal sl opp i tabellene. */
        int skafflookup(int kubeindex[8]);

        void interpoler(sfelt *v1, sfelt *v2, sfelt *r);

        /* triangulerer en kube. */
        int trianguler(int kindex[8], int lookup);
};

#endif

