#include <iostream>
#include "Music.h"

using std::cerr;
using std::endl;

Music::Music()
{
    if (Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 4096) == -1) {
        cerr << "Couldn't initialize SDL_mixer: " << Mix_GetError() << endl;
        error = true;
    }
    else
        error = false;
}

Music::~Music()
{
    Mix_FreeMusic(music);
    Mix_CloseAudio();
}

void Music::loadMusic(const char* filename)
{
    // make sure SDL_mixer was initialized
    if (!error) {
        // try to load the file
        if (!(music = Mix_LoadMUS(filename))) {
            cerr << "Couldn't load music: " << Mix_GetError() << endl;
            error = true;
        }
    }
}

void Music::fadeIn(int milliSeconds)
{
    if (Mix_FadeInMusic(music, 1, milliSeconds) == -1)
        cerr << "Couldn't play music: " << Mix_GetError() << endl;
}

void Music::fadeOut(int milliSeconds)
{
    Mix_FadeOutMusic(milliSeconds);
}
