#ifndef SCENE_H_INCLUDED
#define SCENE_H_INCLUDED

#include <SDL/SDL.h>

class Scene
{
    public:
        Scene();
        virtual ~Scene();
        
        int getTime();
        virtual void init();
        virtual void deinit();
        virtual int run(int milliseconds);
        virtual void render();

    protected:
        SDL_Surface *surface;
        SDL_Event event;
        int done;                   // set to non-zero when scene is done
        unsigned int startTime;     // set to current time when scene starts
        unsigned int framesDrawn;   // stores the number of frames drawn

        void setOrtho();
        void set640x480();
        void unsetOrtho();
};

#endif
