#ifndef VECTOR3D_H_INCLUDED
#define VECTOR3D_H_INCLUDED

#include <iostream>

class Vector3d
{
    public:
        Vector3d(float ix, float iy, float iz): x(ix), y(iy), z(iz) {}
        Vector3d(const Vector3d &copy) {x = copy.x; y = copy.y; z = copy.z;} /* copyconstructor */
        Vector3d() { x = y = z = 0.0; } // [0,0,0]

        Vector3d operator+(Vector3d op2); // adding vectors
        Vector3d operator-(Vector3d op2); // subtracting vectors
        Vector3d operator*(float op2); // scaling vectors

        Vector3d crossProduct(Vector3d op2); // returns the cross product
        float dotProduct(Vector3d op2); // returns the dot product
        float magnitude(); // returns the vectors magnitude
        void normalize(); // makes the vector unit length
        void rotate(float* mat, Vector3d op2);

        void printVector()
        {
            std::cout << "(" << x << ", " << y << ", " << z << ")\n";
        }

        float x, y, z;
};

#endif
