#include <GL/gl.h>
#include <GL/glu.h>
#include "SDLWindow.h"
#include "CelScene.h"
#include "CylinderScene.h"
#include "FunkyBackground.h"
#include "LoaderBar.h"
#include "Greetings.h"
#include "Heightfield.h"
#include "Metaballs.h"
#include "Music.h"

int main(int argc, char *argv[])
{
    SDLWindow *mainWin = new SDLWindow("Xenox-demo lm@o", 640, 480, 16);
    SDL_ShowCursor(SDL_DISABLE);

    // load all scenes and show a progressbar
    LoaderBar* load = new LoaderBar(mainWin->screen);
    load->render(10);
    Music* mu = new Music();
    load->render(20);
    mu->loadMusic("data/Hapungo_-_Demodream4.ogg");
    load->render(50);
    Heightfield* height = new Heightfield(mainWin->screen);
    load->render(60);
    Metaballs *meta = new Metaballs(mainWin->screen);
    load->render(70);
    Greetings* greets = new Greetings(mainWin->screen);
    load->render(80);
    CelScene* cel = new CelScene(mainWin->screen);
    load->render(90);
    Metaballs *meta2 = new Metaballs(mainWin->screen);
    load->render(100);
    FunkyBackground* fun = new FunkyBackground(mainWin->screen);
    load->deinit();
    delete load;

    // start playing music
    if (!mu->error)
        mu->fadeIn(1000);
    else {
        std::cerr << "No music...\n";
        delete mu;
        mu = NULL;
    }
  
    // scene one, the scene that used to be a heightfield :-)
    height->init();
    if (height->run(35000) != 0)
        goto clean_up;
    delete height;

    // scene two, metaballs part 1
    meta->init();
    if (meta->run(25000) != 0)
        goto clean_up;
    delete meta;

    // scene three, greetings
    greets->init();
    if (greets->run(10000) != 0)
        goto clean_up;
    delete greets;

    // scene four, cel-shaded flower
    cel->init();
    if (cel->run(15000) != 0)
        goto clean_up;
    delete cel;

    // scene five, metaballs part 2
    meta2->init();
    if (meta2->run(25000) != 0)
        goto clean_up;
    delete meta2;

    // start fading out music
    mu->fadeOut(5000);

    // scene six, ehmmm....
    fun->init();
    if (fun->run(5000) != 0)
        goto clean_up;
    delete fun;

clean_up:
    delete mu;
    delete mainWin;

    return 0;
}
